/*                     __                                               *\
**     ________ ___   / /  ___     Scala API                            **
**    / __/ __// _ | / /  / _ |    (c) 2003-2006, LAMP/EPFL             **
**  __\ \/ /__/ __ |/ /__/ __ |                                         **
** /____/\___/_/ |_/____/_/ | |                                         **
**                          |/                                          **
\*                                                                      */

// $Id: CountedIterator.scala 6750 2006-03-14 15:59:13 +0000 (Tue, 14 Mar 2006) mihaylov $


package scala;


/** Counted iterators keep track of the number of elements seen so far
 *
 *  @author  Martin Odersky
 *  @version 1.0, 16/07/2003
 */
trait CountedIterator[+A] extends Iterator[A] {

  /** counts the elements in this iterator; counts start at 0
   */
  def count: Int

}
